﻿/*
* 简单的AJAX请求方法
* QQ:909507090
* http://www.qhjsw.net
*
* Copyright (c) 2012 www.qhjsw.net
* version:1.2
* Date: 2012-01-01 16:45:16
*       2013-02-20 23:26:45
*  
*  AJAX方法的用法,参数只有一个参数，为对象{}
*
*   Qhjsw.ajax({
*       type:"POST", //HTTP请求的类型 默认Get  
*        datatype: null,   //       可省略  
*        url: url, //请求的网址(url)   不可省略 
*        timeout:  1000*6, //超时的时间 可省略
*        async:true,       //是否为异步，默认异步false同步
*        onComplete: function () {
*          //do someing 
*         }, //请求失败、成功或者完成都会执行 可省略
*        onError:function (data) {
*         //do someing 
*          alert("Error:"+data);
*         },  //请求失败会执行 可省略
*        onSuccess: function (data) { 
*          //do someing 
*           alert(data);
*        },  //请求成功会自行 不可省略
*        data:"FinderCustomertag=true&Name=111"    //post发送参数 如果请求类型为post则不能省略次参数。此参数可以做为一个对象例如：{"FinderCustomertag":"true",Name:111}
*
*    });
*
*
*
*/
if (typeof Qhjsw!= "object") {
    var Qhjsw = {};
}
Qhjsw.getEle = function (id) { return document.getElementById(id); };
Qhjsw.ajax = function (options) {
    //如果用户没有提供任何一个选项均用默认值代替
    options = {
        type: options.type || "GET", //HTTP请求的类型
        datatype: options.datatype || null,
        url: options.url || "", //请求的网址(url)
        timeout: options.timeout || 1000*6, //超时的时间
        onComplete: options.onComplete || function () { }, //请求失败、成功或者完成都会执行
        onError: options.onError || function () { },
        onSuccess: options.onSuccess || function () { },
        data: options.data || null,    //post发送参数
        async: options.async || true   //是否为异步 false为同步

    };
    //创建XMLHtttpRequest请求对象
    var XMLHttp = window.ActiveXObject ? new ActiveXObject("Microsoft.XMLHTTP") : new XMLHttpRequest();
    var tempurl;
      if(StringIsEmptyOrNull(options.data)&&CheckSendType(options.type)){
        tempurl=options.url+((options.url.indexOf("?")!=-1)?"&":"?")+ConvertPostData(options.data)
      }
      else{
        tempurl=options.url;
      }
    //初始话异步请求
    XMLHttp.open(options.type.toUpperCase(), tempurl, options.async);
    var timeoutLength = options.timeout;  //请求时间指定的秒，超时放弃
    var requestDone = false;  //记录请求是否成功完成
    //初始话一个指定秒后执行的回调函数，用于取消请求
    setTimeout(function () {
        requestDone = true;
    }, timeoutLength);
    //监听文档状态更新，你准备好了吗？
    XMLHttp.onreadystatechange = function () {
        //保持等待，知道数据完全加载，并保证没有超时
        if (XMLHttp.readyState == 4 && !requestDone) {
            //检查请求是否成功
            if (httpSuccess(XMLHttp)) {
                options.onSuccess(httpData(XMLHttp, options.Datatype));
            }
            else {
                options.onError(XMLHttp.status);
            }
            //调用完成回调函数
            options.onComplete();
            XMLHttp = null;
        }

    };
    //建立与服务器的连接
    if (CheckSendType(options.type)) {
        XMLHttp.send(null);
    }
    else {
        XMLHttp.setRequestHeader("cache-control", "no-cache");
        XMLHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;charset=UTF-8');
        XMLHttp.send(ConvertPostData(options.data));
    }
    function httpSuccess(r) {
        try {
            //获取不到服务器的状态，且正在请求本地文件，认为成功
            return !r.status && location.protocol == "file:" ||
            //状态码在200到300的表示成功。文档修改也算成功
                  (r.status >= 200 && r.status < 300) || r.status == 304 ||
                  navigator.userAgent.indexOf("Safari") >= 0 && typeof r.status == "undefined";
        } catch (e) { }
        //若检测失败，就假设请求失败
        return false;
    }
    function httpData(r, type) {
        var ct = r.getResponseHeader("content-type");
        var data = !type && ct && ct.indexOf("xml") >= 0;
        data = type == "xml" || data ? r.responseXML : r.responseText;
        if (type == "script") {
            eval.call(window, data);
        }
        return data;
    }
    //把{}（对象转换为url参数）
       function ConvertPostData(data) {
        var result = [];
        var tmpdata = "";
        var flag = false;
        if(data!=null&&data!=undefined)
        {
         if (data.constructor == Object) {
            flag = true;
            for (var objval in data) {
                if (data[objval].constructor == String || data[objval].constructor == Number) {
                    tmpdata = objval + "=" + data[objval];
                    result.push(tmpdata);
                }
            }
        }
        else {
            result.push(data);
        }
      }
        return flag?result.join("&"):result.toString();
    }
    //判断字符串是否为null或者""
   function StringIsEmptyOrNull(str)
   {  
      var result=true;
      if(str==null||str=="")
      {
        result=false;
      }
      return result;
   }
   //判断请求类型 get请求为true，否则post
   function CheckSendType(type){
     var result=false;
     if (type.toUpperCase() =="GET"){
       result=true;
     }
     return result;
   }
};